Linux tsuru-no-tsurugi 5.15.0-186-generic #196-Ubuntu SMP Sat Jun 20 16:09:34 UTC 2026 x86_64
Apache/2.4.52 (Ubuntu)
Server IP : 192.168.0.18 & Your IP : 216.73.216.68
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
usr /
src /
linux-headers-5.15.0-185 /
scripts /
Delete
Unzip
Name
Size
Permission
Date
Action
atomic
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
basic
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
clang-tools
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
coccinelle
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
dtc
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
dummy-tools
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
gcc-plugins
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
gdb
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
genksyms
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
kconfig
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
ksymoops
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
mod
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
package
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
selinux
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
tracing
[ DIR ]
drwxr-xr-x
2026-06-27 06:50
.gitignore
160
B
-rw-r--r--
2021-11-01 05:53
Kbuild.include
10.15
KB
-rw-r--r--
2026-06-20 00:54
Kconfig.include
2.57
KB
-rw-r--r--
2026-06-20 00:54
Lindent
502
B
-rwxr-xr-x
2021-11-01 05:53
Makefile
1.64
KB
-rw-r--r--
2026-06-20 00:54
Makefile.asm-generic
1.82
KB
-rw-r--r--
2021-11-01 05:53
Makefile.build
19.66
KB
-rw-r--r--
2026-06-20 00:54
Makefile.clang
1.56
KB
-rw-r--r--
2026-06-20 00:54
Makefile.clean
2.2
KB
-rw-r--r--
2021-11-01 05:53
Makefile.compiler
2.74
KB
-rw-r--r--
2026-06-20 00:54
Makefile.dtbinst
1007
B
-rw-r--r--
2026-06-20 00:54
Makefile.extrawarn
3.02
KB
-rw-r--r--
2026-06-20 00:54
Makefile.gcc-plugins
2.71
KB
-rw-r--r--
2026-06-20 00:54
Makefile.headersinst
2.88
KB
-rw-r--r--
2021-11-01 05:53
Makefile.host
4.63
KB
-rw-r--r--
2021-11-01 05:53
Makefile.kasan
1.67
KB
-rw-r--r--
2021-11-01 05:53
Makefile.kcov
333
B
-rw-r--r--
2021-11-01 05:53
Makefile.kcsan
739
B
-rw-r--r--
2021-11-01 05:53
Makefile.lib
18.02
KB
-rw-r--r--
2026-06-20 00:54
Makefile.modfinal
2.73
KB
-rw-r--r--
2026-06-20 00:54
Makefile.modinst
2.52
KB
-rw-r--r--
2026-06-20 00:54
Makefile.modpost
4.37
KB
-rw-r--r--
2026-06-20 00:54
Makefile.package
6.61
KB
-rw-r--r--
2021-11-01 05:53
Makefile.ubsan
770
B
-rw-r--r--
2026-06-20 00:54
Makefile.userprogs
1.57
KB
-rw-r--r--
2021-11-01 05:53
adjust_autoksyms.sh
2.07
KB
-rwxr-xr-x
2021-11-01 05:53
as-version.sh
2.03
KB
-rwxr-xr-x
2026-06-20 00:54
asn1_compiler.c
35.33
KB
-rw-r--r--
2026-06-20 00:54
bin2c.c
743
B
-rw-r--r--
2021-11-01 05:53
bloat-o-meter
3.36
KB
-rwxr-xr-x
2021-11-01 05:53
bootgraph.pl
5.64
KB
-rwxr-xr-x
2021-11-01 05:53
bpf_doc.py
24.98
KB
-rwxr-xr-x
2026-06-20 00:54
cc-can-link.sh
166
B
-rwxr-xr-x
2021-11-01 05:53
cc-version.sh
1.51
KB
-rwxr-xr-x
2021-11-01 05:53
check-sysctl-docs
4.37
KB
-rwxr-xr-x
2021-11-01 05:53
check_extable.sh
4.93
KB
-rwxr-xr-x
2021-11-01 05:53
checkdeclares.pl
1.1
KB
-rwxr-xr-x
2021-11-01 05:53
checkincludes.pl
1.94
KB
-rwxr-xr-x
2021-11-01 05:53
checkkconfigsymbols.py
15.75
KB
-rwxr-xr-x
2026-06-20 00:54
checkpatch.pl
223.76
KB
-rwxr-xr-x
2026-06-20 00:54
checkstack.pl
5.86
KB
-rwxr-xr-x
2026-06-20 00:54
checksyscalls.sh
7.42
KB
-rwxr-xr-x
2021-11-01 05:53
checkversion.pl
2.16
KB
-rwxr-xr-x
2021-11-01 05:53
cleanfile
3.46
KB
-rwxr-xr-x
2021-11-01 05:53
cleanpatch
5.06
KB
-rwxr-xr-x
2021-11-01 05:53
coccicheck
7.89
KB
-rwxr-xr-x
2021-11-01 05:53
config
4.78
KB
-rwxr-xr-x
2026-06-20 00:54
const_structs.checkpatch
1009
B
-rw-r--r--
2021-11-01 05:53
decode_stacktrace.sh
7.51
KB
-rwxr-xr-x
2026-06-20 00:54
decodecode
2.88
KB
-rwxr-xr-x
2021-11-01 05:53
depmod.sh
1.41
KB
-rwxr-xr-x
2021-11-01 05:53
dev-needs.sh
6.07
KB
-rwxr-xr-x
2021-11-01 05:53
diffconfig
4.12
KB
-rwxr-xr-x
2026-06-20 00:54
documentation-file-ref-check
5.55
KB
-rwxr-xr-x
2021-11-01 05:53
export_report.pl
4.5
KB
-rwxr-xr-x
2021-11-01 05:53
extract-cert.c
3.63
KB
-rw-r--r--
2026-06-20 00:54
extract-ikconfig
1.69
KB
-rwxr-xr-x
2021-11-01 05:53
extract-module-sig.pl
3.66
KB
-rwxr-xr-x
2021-11-01 05:53
extract-sys-certs.pl
3.75
KB
-rwxr-xr-x
2021-11-01 05:53
extract-vmlinux
1.66
KB
-rwxr-xr-x
2021-11-01 05:53
extract_xc3028.pl
44.62
KB
-rwxr-xr-x
2021-11-01 05:53
faddr2line
8.17
KB
-rwxr-xr-x
2026-06-20 00:54
file-size.sh
86
B
-rwxr-xr-x
2021-11-01 05:53
find-unused-docs.sh
1.27
KB
-rwxr-xr-x
2021-11-01 05:53
gcc-goto.sh
511
B
-rwxr-xr-x
2021-11-01 05:53
gcc-ld
711
B
-rwxr-xr-x
2021-11-01 05:53
gcc-x86_32-has-stack-protector.sh
405
B
-rwxr-xr-x
2026-06-20 00:54
gcc-x86_64-has-stack-protector.sh
195
B
-rwxr-xr-x
2026-06-20 00:54
gen_autoksyms.sh
1.47
KB
-rwxr-xr-x
2021-11-01 05:53
gen_ksymdeps.sh
556
B
-rwxr-xr-x
2021-11-01 05:53
generate_initcall_order.pl
5.95
KB
-rwxr-xr-x
2021-11-01 05:53
get_abi.pl
15.1
KB
-rwxr-xr-x
2026-06-20 00:54
get_dvb_firmware
24.54
KB
-rwxr-xr-x
2021-11-01 05:53
get_feat.pl
14.34
KB
-rwxr-xr-x
2021-11-01 05:53
get_maintainer.pl
67.13
KB
-rwxr-xr-x
2021-11-01 05:53
gfp-translate
1.69
KB
-rwxr-xr-x
2021-11-01 05:53
headerdep.pl
3.5
KB
-rwxr-xr-x
2021-11-01 05:53
headers_check.pl
3.73
KB
-rwxr-xr-x
2021-11-01 05:53
headers_install.sh
3.35
KB
-rwxr-xr-x
2021-11-01 05:53
insert-sys-cert.c
13.08
KB
-rw-r--r--
2026-06-20 00:54
jobserver-exec
2.16
KB
-rwxr-xr-x
2021-11-01 05:53
kallsyms.c
18.06
KB
-rw-r--r--
2021-11-01 05:53
kernel-doc
68.74
KB
-rwxr-xr-x
2026-06-20 00:54
ld-version.sh
1.82
KB
-rwxr-xr-x
2026-06-20 00:54
leaking_addresses.pl
12.8
KB
-rwxr-xr-x
2026-06-20 00:54
link-vmlinux.sh
10.92
KB
-rwxr-xr-x
2026-06-20 00:54
makelst
808
B
-rwxr-xr-x
2021-11-01 05:53
markup_oops.pl
7.92
KB
-rwxr-xr-x
2021-11-01 05:53
min-tool-version.sh
558
B
-rwxr-xr-x
2021-11-01 05:53
mkcompile_h
2.48
KB
-rwxr-xr-x
2021-11-01 05:53
mksysmap
1.34
KB
-rwxr-xr-x
2026-06-20 00:54
mkuboot.sh
414
B
-rwxr-xr-x
2021-11-01 05:53
module.lds.S
1.65
KB
-rw-r--r--
2026-06-20 00:54
modules-check.sh
427
B
-rwxr-xr-x
2021-11-01 05:53
nsdeps
1.72
KB
-rw-r--r--
2021-11-01 05:53
objdiff
2.84
KB
-rwxr-xr-x
2021-11-01 05:53
pahole-flags.sh
749
B
-rwxr-xr-x
2026-06-20 00:54
pahole-version.sh
269
B
-rwxr-xr-x
2026-06-20 00:54
parse-maintainers.pl
4.54
KB
-rwxr-xr-x
2021-11-01 05:53
patch-kernel
9.95
KB
-rwxr-xr-x
2021-11-01 05:53
profile2linkerlist.pl
414
B
-rwxr-xr-x
2021-11-01 05:53
prune-kernel
708
B
-rwxr-xr-x
2021-11-01 05:53
recordmcount.c
16.75
KB
-rw-r--r--
2026-06-20 00:54
recordmcount.h
19.37
KB
-rw-r--r--
2021-11-01 05:53
recordmcount.pl
17.63
KB
-rwxr-xr-x
2026-06-20 00:54
remove-stale-files
1.3
KB
-rwxr-xr-x
2021-11-01 05:53
setlocalversion
3.5
KB
-rwxr-xr-x
2021-11-01 05:53
show_delta
3.01
KB
-rwxr-xr-x
2021-11-01 05:53
sign-file.c
9.93
KB
-rw-r--r--
2026-06-20 00:54
sorttable.c
8.74
KB
-rw-r--r--
2026-06-20 00:54
sorttable.h
9.83
KB
-rw-r--r--
2026-06-20 00:54
spdxcheck-test.sh
277
B
-rw-r--r--
2021-11-01 05:53
spdxcheck.py
10.09
KB
-rwxr-xr-x
2021-11-01 05:53
spelling.txt
31.88
KB
-rw-r--r--
2021-11-01 05:53
sphinx-pre-install
24.45
KB
-rwxr-xr-x
2026-06-20 00:54
split-man.pl
604
B
-rwxr-xr-x
2021-11-01 05:53
stackdelta
1.84
KB
-rwxr-xr-x
2021-11-01 05:53
stackusage
794
B
-rwxr-xr-x
2021-11-01 05:53
subarch.include
619
B
-rw-r--r--
2021-11-01 05:53
syscallhdr.sh
1.89
KB
-rwxr-xr-x
2021-11-01 05:53
syscallnr.sh
1.45
KB
-rwxr-xr-x
2021-11-01 05:53
syscalltbl.sh
1.45
KB
-rwxr-xr-x
2021-11-01 05:53
tags.sh
9.87
KB
-rwxr-xr-x
2026-06-20 00:54
tools-support-relr.sh
546
B
-rwxr-xr-x
2021-11-01 05:53
ubuntu-retpoline-extract-one
7.26
KB
-rw-r--r--
2026-06-20 00:54
unifdef.c
34.8
KB
-rw-r--r--
2021-11-01 05:53
ver_linux
2.59
KB
-rwxr-xr-x
2021-11-01 05:53
xen-hypercalls.sh
386
B
-rwxr-xr-x
2021-11-01 05:53
xz_wrap.sh
563
B
-rwxr-xr-x
2021-11-01 05:53
Save
Rename
#!/bin/bash # SPDX-License-Identifier: GPL-2.0 # # Translate stack dump function offsets. # # addr2line doesn't work with KASLR addresses. This works similarly to # addr2line, but instead takes the 'func+0x123' format as input: # # $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568 # meminfo_proc_show+0x5/0x568: # meminfo_proc_show at fs/proc/meminfo.c:27 # # If the address is part of an inlined function, the full inline call chain is # printed: # # $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27 # native_write_msr+0x6/0x27: # arch_static_branch at arch/x86/include/asm/msr.h:121 # (inlined by) static_key_false at include/linux/jump_label.h:125 # (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125 # # The function size after the '/' in the input is optional, but recommended. # It's used to help disambiguate any duplicate symbol names, which can occur # rarely. If the size is omitted for a duplicate symbol then it's possible for # multiple code sites to be printed: # # $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5 # raw_ioctl+0x5/0x20: # raw_ioctl at drivers/char/raw.c:122 # # raw_ioctl+0x5/0xb1: # raw_ioctl at net/ipv4/raw.c:876 # # Multiple addresses can be specified on a single command line: # # $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90 # type_show+0x10/0x2d: # type_show at drivers/video/backlight/backlight.c:213 # # free_reserved_area+0x90/0x123: # free_reserved_area at mm/page_alloc.c:6429 (discriminator 2) set -o errexit set -o nounset usage() { echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2 exit 1 } warn() { echo "$1" >&2 } die() { echo "ERROR: $1" >&2 exit 1 } READELF="${CROSS_COMPILE:-}readelf" ADDR2LINE="${CROSS_COMPILE:-}addr2line" AWK="awk" command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed" command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed" command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed" # Try to figure out the source directory prefix so we can remove it from the # addr2line output. HACK ALERT: This assumes that start_kernel() is in # init/main.c! This only works for vmlinux. Otherwise it falls back to # printing the absolute path. find_dir_prefix() { local objfile=$1 local start_kernel_addr=$(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}') [[ -z $start_kernel_addr ]] && return local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr) [[ -z $file_line ]] && return local prefix=${file_line%init/main.c:*} if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then return fi DIR_PREFIX=$prefix return 0 } __faddr2line() { local objfile=$1 local func_addr=$2 local dir_prefix=$3 local print_warnings=$4 local sym_name=${func_addr%+*} local func_offset=${func_addr#*+} func_offset=${func_offset%/*} local user_size= local file_type local is_vmlinux=0 [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/} if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then warn "bad func+offset $func_addr" DONE=1 return fi # vmlinux uses absolute addresses in the section table rather than # section offsets. local file_type=$(${READELF} --file-header $objfile | ${AWK} '$1 == "Type:" { print $2; exit }') if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then is_vmlinux=1 fi # Go through each of the object's symbols which match the func name. # In rare cases there might be duplicates, in which case we print all # matches. while read line; do local fields=($line) local sym_addr=0x${fields[1]} local sym_elf_size=${fields[2]} local sym_sec=${fields[6]} local sec_size local sec_name # Get the section size: sec_size=$(${READELF} --section-headers --wide $objfile | sed 's/\[ /\[/' | ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }') if [[ -z $sec_size ]]; then warn "bad section size: section: $sym_sec" DONE=1 return fi # Get the section name: sec_name=$(${READELF} --section-headers --wide $objfile | sed 's/\[ /\[/' | ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }') if [[ -z $sec_name ]]; then warn "bad section name: section: $sym_sec" DONE=1 return fi # Calculate the symbol size. # # Unfortunately we can't use the ELF size, because kallsyms # also includes the padding bytes in its size calculation. For # kallsyms, the size calculation is the distance between the # symbol and the next symbol in a sorted list. local sym_size local cur_sym_addr local found=0 while read line; do local fields=($line) cur_sym_addr=0x${fields[1]} local cur_sym_elf_size=${fields[2]} local cur_sym_name=${fields[7]:-} if [[ $cur_sym_addr = $sym_addr ]] && [[ $cur_sym_elf_size = $sym_elf_size ]] && [[ $cur_sym_name = $sym_name ]]; then found=1 continue fi if [[ $found = 1 ]]; then sym_size=$(($cur_sym_addr - $sym_addr)) [[ $sym_size -lt $sym_elf_size ]] && continue; found=2 break fi done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2) if [[ $found = 0 ]]; then warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size" DONE=1 return fi # If nothing was found after the symbol, assume it's the last # symbol in the section. [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr)) if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr" DONE=1 return fi sym_size=0x$(printf %x $sym_size) # Calculate the address from user-supplied offset: local addr=$(($sym_addr + $func_offset)) if [[ -z $addr ]] || [[ $addr = 0 ]]; then warn "bad address: $sym_addr + $func_offset" DONE=1 return fi addr=0x$(printf %x $addr) # If the user provided a size, make sure it matches the symbol's size: if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then [[ $print_warnings = 1 ]] && echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)" continue; fi # Make sure the provided offset is within the symbol's range: if [[ $func_offset -gt $sym_size ]]; then [[ $print_warnings = 1 ]] && echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)" continue fi # In case of duplicates or multiple addresses specified on the # cmdline, separate multiple entries with a blank line: [[ $FIRST = 0 ]] && echo FIRST=0 echo "$sym_name+$func_offset/$sym_size:" # Pass section address to addr2line and strip absolute paths # from the output: local args="--functions --pretty-print --inlines --exe=$objfile" [[ $is_vmlinux = 0 ]] && args="$args --section=$sec_name" local output=$(${ADDR2LINE} $args $addr | sed "s; $dir_prefix\(\./\)*; ;") [[ -z $output ]] && continue # Default output (non --list): if [[ $LIST = 0 ]]; then echo "$output" | while read -r line do echo $line done DONE=1; continue fi # For --list, show each line with its corresponding source code: echo "$output" | while read -r line do echo echo $line n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g') n1=$[$n-5] n2=$[$n+5] f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g') ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f done DONE=1 done < <(${READELF} --symbols --wide $objfile | sed 's/\[.*\]//' | ${AWK} -v fn=$sym_name '$4 == "FUNC" && $8 == fn') } [[ $# -lt 2 ]] && usage objfile=$1 LIST=0 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1 [[ ! -f $objfile ]] && die "can't find objfile $objfile" shift DIR_PREFIX=supercalifragilisticexpialidocious find_dir_prefix $objfile FIRST=1 while [[ $# -gt 0 ]]; do func_addr=$1 shift # print any matches found DONE=0 __faddr2line $objfile $func_addr $DIR_PREFIX 0 # if no match was found, print warnings if [[ $DONE = 0 ]]; then __faddr2line $objfile $func_addr $DIR_PREFIX 1 warn "no match for $func_addr" fi done